// -*- C++ -*-
/***************************************************************************
                          mem.h  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef MEM_H
#define MEM_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>		/* size_t; actually stddef.h, but stdlib.h
				   might be more reliable? --dwp */

/* cap_malloc, cap_realloc, cap_calloc:
 * cap_ stands for capitalist; the return value is checked,
 * and capitalist-specific processing occurs if it is NULL:
 * a log message, possibly cleanup, and ending with exit(1)
 */
   
#define cap_malloc(sz)      cap_real_malloc((sz), "malloc", \
					  __LINE__, __FILE__)
#define cap_realloc(ptr,sz) cap_real_realloc((ptr), (sz), "realloc", \
					   __LINE__, __FILE__)
#define cap_calloc(n,esz)   cap_real_calloc((n), (esz), "calloc", \
					   __LINE__, __FILE__)

#define mystrdup(str)      real_mystrdup((str), "strdup", \
					 __LINE__, __FILE__)
     
/***********************************************************************/

/* You shouldn't call these functions directly;
 * use the macros above instead.
 */
void *cap_real_malloc(size_t size,
		     const char *called_as, int line, const char *file);
void *cap_real_realloc(void *ptr, size_t size,
		      const char *called_as, int line, const char *file);
void *cap_real_calloc(size_t nelem, size_t elsize,
		     const char *called_as, int line, const char *file);

char *real_mystrdup(const char *str, 
		    const char *called_as, int line, const char *file);

#endif /* MEM_H */
